質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.51%

  • Python

    11702questions

    Pythonは、コードの読みやすさが特徴的なプログラミング言語の1つです。 強い型付け、動的型付けに対応しており、後方互換性がないバージョン2系とバージョン3系が使用されています。 商用製品の開発にも無料で使用でき、OSだけでなく仮想環境にも対応。Unicodeによる文字列操作をサポートしているため、日本語処理も標準で可能です。

Pythonにて

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 661

kaitokimura

score 51

例えばhttp://sample.com/a/b/c/d/e/1?ima=0000&cd=member 
にブログの1ページ目があるとします。 
2ページ目は 
http://sample.com/a/b/c/d/e/2?ima=0000&cd=memberにあるとします。 
このブログをBeautiful Soup 4を使って1ページ目から読み込みたいのですが 
ときどき記事が削除されて404がでているときに
そのエラーを受け取ったら次のページにいきたいのですがうまく行きません。

#!/usr/bin/env python
# -*- coding: utf-8 -*-
from urllib.request import urlopen
from urllib.error import URLError, HTTPError
from bs4 import BeautifulSoup
import os
url = 'http://sample.com/a/b/c/d/e/{}?ima=0000&cd=member'
try:
    for i in range(1, 1000):
        html = urlopen(url.format(str(i)))
        soup = BeautifulSoup(html)
        print(soup.find('div',{'class':'headArea'}).p.text)

except HTTPError as e:
    for i in range(i+1, 1000):
        html = urlopen(url.format(str(i)))
        soup = BeautifulSoup(html)
        print('Error code: ', e.code)
except URLError as e:
    for i in range(i+1, 1000):
        html = urlopen(url.format(str(i)))
        soup = BeautifulSoup(html)
        print('Reason: ', e.reason)


エラーメッセージ

Traceback (most recent call last):
  File "sample.py", line 21, in <module>
    html = urlopen(url.format(str(i)))
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 223, in urlopen
    return opener.open(url, data, timeout)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 532, in open
    response = meth(req, response)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 642, in http_response
    'http', request, response, code, msg, hdrs)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 570, in error
    return self._call_chain(*args)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 504, in _call_chain
    result = func(*args)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 650, in http_error_default
    raise HTTPError(req.full_url, code, msg, hdrs, fp)
urllib.error.HTTPError: HTTP Error 404: Not Found

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "sample.py", line 27, in <module>
    html = urlopen(url.format(str(i)))
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 223, in urlopen
    return opener.open(url, data, timeout)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 532, in open
    response = meth(req, response)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 642, in http_response
    'http', request, response, code, msg, hdrs)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 570, in error
    return self._call_chain(*args)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 504, in _call_chain
    result = func(*args)
  File "/Users/Mypc/.pyenv/versions/3.6.1/lib/python3.6/urllib/request.py", line 650, in http_error_default
    raise HTTPError(req.full_url, code, msg, hdrs, fp)
urllib.error.HTTPError: HTTP Error 404: Not Found
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

0

try 〜 except は for の中に入れましょう。

for i in range(1, 1000):
    try:
        html = urlopen(url.format(str(i)))
    except:
        # 例外処理
    else:
        # 成功したときの処理

元サイトに迷惑がかかるので、適度にsleep処理をいれるべきです。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/05/03 21:58

    sleep処理かしこまりました。
    '''UserWarning: No parser was explicitly specified, so I'm using the best available HTML parser for this system ("lxml"). This usually isn't a problem, but if you run this code on another system, or in a different virtual environment, it may use a different parser and behave differently.

    The code that caused this warning is on line 33 of the file sample.py. To get rid of this warning, change code that looks like this:

    BeautifulSoup([your markup])

    to this:

    BeautifulSoup([your markup], "lxml")

    markup_type=markup_type))
    5000
    Traceback (most recent call last):
    File "sample.py", line 36, in <module>
    print('Reason: ', e.reason)
    NameError: name 'e' is not defined'''
    これはどういう意味でしょうか。。。

    キャンセル

  • 2017/05/03 22:04

    except hogehoge as e:
    のeを定義していないのではないでしょうか

    キャンセル

  • 2017/05/04 16:04

    except HTTPError as e:とexcept URLError as e:を設けてますがここではないですか??

    キャンセル

同じタグがついた質問を見る

  • Python

    11702questions

    Pythonは、コードの読みやすさが特徴的なプログラミング言語の1つです。 強い型付け、動的型付けに対応しており、後方互換性がないバージョン2系とバージョン3系が使用されています。 商用製品の開発にも無料で使用でき、OSだけでなく仮想環境にも対応。Unicodeによる文字列操作をサポートしているため、日本語処理も標準で可能です。